--Revision control and source backup
with trace
include file.e
include files.e

sequence cmd,files,currentDir,sourceDir,todays_date,date2
atom filelist_h
currentDir=current_dir()

--trace(1)
--open list of files to back up, including wildcards
cmd=command_line()
if length(cmd) < 3 then
    puts(1,"Usage: ex srcbak filelist [dirname] [batch file]\n") 
    --options go here
    puts(1,"  Dirname is the directory to back up\n") 
    puts(1,"  Batch file is a file to run when finished, for compressing files for example")
    abort(1)
end if      
trace(1)
if length(cmd) =4 then        --if dirname specified
    sourceDir=cmd[4]    
    if sourceDir[length(sourceDir)] != '\\' then  --if no trailing '\' then tack it on
        sourceDir=sourceDir & '\\'
    end if
else
    sourceDir=""              --current dir
end if

filelist_h=open(sourceDir&cmd[3],"r")
if filelist_h = -1 then
    puts(1,"Can't open file list")
    abort(2)    
end if

files=read_file(filelist_h)
    --need to trim off last filename if it is an enter
if compare(files[length(files)],"")=0 then   --it should be empty because the LF has been trimmed, but it may be CRLF
    files=files[1..length(files)-1]     
end if
--check if srcbak exists, if not create
if not dir_exist("srcbak") then
    --create it
    system("mkdir "& sourceDir &"srcbak",2)   --probably prepend source code dir to srcbak    
end if

--get current date and create a sub-dir with the name in the format of DDMMYYYY
todays_date=date()
date2= sprintf("%02d",todays_date[3]) & 
       sprintf("%02d",todays_date[2]) &
       sprintf("%04d",todays_date[1]+1900)
if not dir_exist(sourceDir & "srcbak\\" & date2) then
    system("mkdir "& sourceDir &"srcbak"&"\\"&date2,2)        
end if
    
--copy files to be backed up into srcbak\DDMMYYYY
for x=1 to length(files) do
    system("copy "&sourceDir & files[x] & " " & sourceDir & "srcbak\\" & date2,2)
end for

--(optional) run separate program to zip up src tree
if length(cmd)=5 then
    system(cmd[5],0)
end if

